import { world } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:alexa_on", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`execute if entity @p[m=survival,r=5] run summon furnicraft:smart_horn menu ~ ~ ~`)
                    chairEntity.runCommand(`summon furnicraft:smart_horn_menu`)
                    break;
                case 'south':
                    chairEntity.runCommand(`execute if entity @p[m=survival,r=5] run summon furnicraft:smart_horn menu ~ ~ ~`)
                    chairEntity.runCommand(`summon furnicraft:smart_horn_menu`)
                    break;
                case 'east':
                    chairEntity.runCommand(`execute if entity @p[m=survival,r=5] run summon furnicraft:smart_horn menu ~ ~ ~`)
                    chairEntity.runCommand(`summon furnicraft:smart_horn_menu`)
                    break;
                case 'west':
                    chairEntity.runCommand(`execute if entity @p[m=survival,r=5] run summon furnicraft:smart_horn menu ~ ~ ~`)
                    chairEntity.runCommand(`summon furnicraft:smart_horn_menu`)
                    break;
            }

        },
    });
});