import { world, GameMode, BlockPermutation } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:open_gifts", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();
            const chairEntity = dimension.spawnEntity("furnicraft:randomgift",{ x: blockCenter.x, y: blockCenter.y - 0.0, z: blockCenter.z })
            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    break;
                case 'south':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    break;
                case 'east':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    break;
                case 'west':
                    block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    break;
            }
        },
    });
});

//ticking 6,6
