import { world, BlockPermutation } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:table", {
        onPlace: e => {
            const { player, block, previousBlock } = e;

            if ( block.north().hasTag("table") ) {
                block.setPermutation(block.permutation.withState("furnicraft:north",true));
                block.north().setPermutation(block.north().permutation.withState("furnicraft:south",true));
            }
            if ( block.south().hasTag("table") ) {
                block.setPermutation(block.permutation.withState("furnicraft:south",true));
                block.south().setPermutation(block.south().permutation.withState("furnicraft:north",true));
            }
            if ( block.west().hasTag("table") ) {
                block.setPermutation(block.permutation.withState("furnicraft:west",true));
                block.west().setPermutation(block.west().permutation.withState("furnicraft:east",true));
            }
            if ( block.east().hasTag("table") ) {
                block.setPermutation(block.permutation.withState("furnicraft:east",true));
                block.east().setPermutation(block.east().permutation.withState("furnicraft:west",true));
            }
        },
        onPlayerDestroy: e => {
            const { player, block, dimension } = e;
            if ( block.north().hasTag("table") ) {
                block.north().setPermutation(block.north().permutation.withState("furnicraft:south",false));
            }
            if ( block.south().hasTag("table") ) {
                block.south().setPermutation(block.south().permutation.withState("furnicraft:north",false));
            }
            if ( block.west().hasTag("table") ) {
                block.west().setPermutation(block.west().permutation.withState("furnicraft:east",false));
            }
            if ( block.east().hasTag("table") ) {
                block.east().setPermutation(block.east().permutation.withState("furnicraft:west",false));
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:glasstable", {
        onPlace: e => {
            const { player, block, previousBlock } = e;

            if ( block.north().hasTag("glasstable") ) {
                block.setPermutation(block.permutation.withState("furnicraft:north",true));
                block.north().setPermutation(block.north().permutation.withState("furnicraft:south",true));
            }
            if ( block.south().hasTag("glasstable") ) {
                block.setPermutation(block.permutation.withState("furnicraft:south",true));
                block.south().setPermutation(block.south().permutation.withState("furnicraft:north",true));
            }
            if ( block.west().hasTag("glasstable") ) {
                block.setPermutation(block.permutation.withState("furnicraft:west",true));
                block.west().setPermutation(block.west().permutation.withState("furnicraft:east",true));
            }
            if ( block.east().hasTag("glasstable") ) {
                block.setPermutation(block.permutation.withState("furnicraft:east",true));
                block.east().setPermutation(block.east().permutation.withState("furnicraft:west",true));
            }
        },
        onPlayerDestroy: e => {
            const { player, block, dimension } = e;
            if ( block.north().hasTag("glasstable") ) {
                block.north().setPermutation(block.north().permutation.withState("furnicraft:south",false));
            }
            if ( block.south().hasTag("glasstable") ) {
                block.south().setPermutation(block.south().permutation.withState("furnicraft:north",false));
            }
            if ( block.west().hasTag("glasstable") ) {
                block.west().setPermutation(block.west().permutation.withState("furnicraft:east",false));
            }
            if ( block.east().hasTag("glasstable") ) {
                block.east().setPermutation(block.east().permutation.withState("furnicraft:west",false));
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:colortable", {
        onPlace: e => {
            const { player, block, previousBlock } = e;

            if ( block.north().hasTag("colortable") ) {
                block.setPermutation(block.permutation.withState("furnicraft:north",true));
                block.north().setPermutation(block.north().permutation.withState("furnicraft:south",true));
            }
            if ( block.south().hasTag("colortable") ) {
                block.setPermutation(block.permutation.withState("furnicraft:south",true));
                block.south().setPermutation(block.south().permutation.withState("furnicraft:north",true));
            }
            if ( block.west().hasTag("colortable") ) {
                block.setPermutation(block.permutation.withState("furnicraft:west",true));
                block.west().setPermutation(block.west().permutation.withState("furnicraft:east",true));
            }
            if ( block.east().hasTag("colortable") ) {
                block.setPermutation(block.permutation.withState("furnicraft:east",true));
                block.east().setPermutation(block.east().permutation.withState("furnicraft:west",true));
            }
        },
        onPlayerDestroy: e => {
            const { player, block, dimension } = e;
            if ( block.north().hasTag("colortable") ) {
                block.north().setPermutation(block.north().permutation.withState("furnicraft:south",false));
            }
            if ( block.south().hasTag("colortable") ) {
                block.south().setPermutation(block.south().permutation.withState("furnicraft:north",false));
            }
            if ( block.west().hasTag("colortable") ) {
                block.west().setPermutation(block.west().permutation.withState("furnicraft:east",false));
            }
            if ( block.east().hasTag("colortable") ) {
                block.east().setPermutation(block.east().permutation.withState("furnicraft:west",false));
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:desk", {
        onPlace: e => {
            const { player, block, previousBlock } = e;

            if ( block.north().hasTag("desk") ) {
                block.setPermutation(block.permutation.withState("furnicraft:north",true));
                block.north().setPermutation(block.north().permutation.withState("furnicraft:south",true));
            }
            if ( block.south().hasTag("desk") ) {
                block.setPermutation(block.permutation.withState("furnicraft:south",true));
                block.south().setPermutation(block.south().permutation.withState("furnicraft:north",true));
            }
            if ( block.west().hasTag("desk") ) {
                block.setPermutation(block.permutation.withState("furnicraft:west",true));
                block.west().setPermutation(block.west().permutation.withState("furnicraft:east",true));
            }
            if ( block.east().hasTag("desk") ) {
                block.setPermutation(block.permutation.withState("furnicraft:east",true));
                block.east().setPermutation(block.east().permutation.withState("furnicraft:west",true));
            }
        },
        onPlayerDestroy: e => {
            const { player, block, dimension } = e;
            if ( block.north().hasTag("desk") ) {
                block.north().setPermutation(block.north().permutation.withState("furnicraft:south",false));
            }
            if ( block.south().hasTag("desk") ) {
                block.south().setPermutation(block.south().permutation.withState("furnicraft:north",false));
            }
            if ( block.west().hasTag("desk") ) {
                block.west().setPermutation(block.west().permutation.withState("furnicraft:east",false));
            }
            if ( block.east().hasTag("desk") ) {
                block.east().setPermutation(block.east().permutation.withState("furnicraft:west",false));
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:market_table", {
        onPlace: e => {
            const { player, block, previousBlock } = e;

            if ( block.north().hasTag("market_table") ) {
                block.setPermutation(block.permutation.withState("furnicraft:north",true));
                block.north().setPermutation(block.north().permutation.withState("furnicraft:south",true));
            }
            if ( block.south().hasTag("market_table") ) {
                block.setPermutation(block.permutation.withState("furnicraft:south",true));
                block.south().setPermutation(block.south().permutation.withState("furnicraft:north",true));
            }
            if ( block.west().hasTag("market_table") ) {
                block.setPermutation(block.permutation.withState("furnicraft:west",true));
                block.west().setPermutation(block.west().permutation.withState("furnicraft:east",true));
            }
            if ( block.east().hasTag("market_table") ) {
                block.setPermutation(block.permutation.withState("furnicraft:east",true));
                block.east().setPermutation(block.east().permutation.withState("furnicraft:west",true));
            }
        },
        onPlayerDestroy: e => {
            const { player, block, dimension } = e;
            if ( block.north().hasTag("market_table") ) {
                block.north().setPermutation(block.north().permutation.withState("furnicraft:south",false));
            }
            if ( block.south().hasTag("market_table") ) {
                block.south().setPermutation(block.south().permutation.withState("furnicraft:north",false));
            }
            if ( block.west().hasTag("market_table") ) {
                block.west().setPermutation(block.west().permutation.withState("furnicraft:east",false));
            }
            if ( block.east().hasTag("market_table") ) {
                block.east().setPermutation(block.east().permutation.withState("furnicraft:west",false));
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:kitchen_table", {
        onPlace: e => {
            const { player, block, previousBlock } = e;

            if ( block.north().hasTag("kitchen") ) {
                block.setPermutation(block.permutation.withState("furnicraft:north",true));
                block.north().setPermutation(block.north().permutation.withState("furnicraft:south",true));
            }
            if ( block.south().hasTag("kitchen") ) {
                block.setPermutation(block.permutation.withState("furnicraft:south",true));
                block.south().setPermutation(block.south().permutation.withState("furnicraft:north",true));
            }
            if ( block.west().hasTag("kitchen") ) {
                block.setPermutation(block.permutation.withState("furnicraft:west",true));
                block.west().setPermutation(block.west().permutation.withState("furnicraft:east",true));
            }
            if ( block.east().hasTag("kitchen") ) {
                block.setPermutation(block.permutation.withState("furnicraft:east",true));
                block.east().setPermutation(block.east().permutation.withState("furnicraft:west",true));
            }
        },
        onPlayerDestroy: e => {
            const { player, block, dimension } = e;
            if ( block.north().hasTag("kitchen") ) {
                block.north().setPermutation(block.north().permutation.withState("furnicraft:south",false));
            }
            if ( block.south().hasTag("kitchen") ) {
                block.south().setPermutation(block.south().permutation.withState("furnicraft:north",false));
            }
            if ( block.west().hasTag("kitchen") ) {
                block.west().setPermutation(block.west().permutation.withState("furnicraft:east",false));
            }
            if ( block.east().hasTag("kitchen") ) {
                block.east().setPermutation(block.east().permutation.withState("furnicraft:west",false));
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:bar_table", {
        onPlace: e => {
            const { player, block, previousBlock } = e;

            if ( block.north().hasTag("bar_table") ) {
                block.setPermutation(block.permutation.withState("furnicraft:north",true));
                block.north().setPermutation(block.north().permutation.withState("furnicraft:south",true));
            }
            if ( block.south().hasTag("bar_table") ) {
                block.setPermutation(block.permutation.withState("furnicraft:south",true));
                block.south().setPermutation(block.south().permutation.withState("furnicraft:north",true));
            }
            if ( block.west().hasTag("bar_table") ) {
                block.setPermutation(block.permutation.withState("furnicraft:west",true));
                block.west().setPermutation(block.west().permutation.withState("furnicraft:east",true));
            }
            if ( block.east().hasTag("bar_table") ) {
                block.setPermutation(block.permutation.withState("furnicraft:east",true));
                block.east().setPermutation(block.east().permutation.withState("furnicraft:west",true));
            }
        },
        onPlayerDestroy: e => {
            const { player, block, dimension } = e;
            if ( block.north().hasTag("bar_table") ) {
                block.north().setPermutation(block.north().permutation.withState("furnicraft:south",false));
            }
            if ( block.south().hasTag("bar_table") ) {
                block.south().setPermutation(block.south().permutation.withState("furnicraft:north",false));
            }
            if ( block.west().hasTag("bar_table") ) {
                block.west().setPermutation(block.west().permutation.withState("furnicraft:east",false));
            }
            if ( block.east().hasTag("bar_table") ) {
                block.east().setPermutation(block.east().permutation.withState("furnicraft:west",false));
            }
        },
    });
});