import { world, GameMode, BlockPermutation } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:opentv", {
        onPlayerInteract: e => {
            const { player, block, dimension, face, faceLocation} = e;
            const blockLocation = block.center()
            const blockFaceLocation = block.permutation.getState("minecraft:block_face");
            let animationEntity;
            switch(blockFaceLocation){
                case 'north':
                    if ( face === 'North'){
                        block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    }
                    break;
                case 'south':
                    if ( face === 'South'){
                        block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    }
                    break;
                case 'east':
                    if ( face === 'East'){
                        block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    }
                    break;
                case 'west':
                    if ( face === 'West'){
                        block.setPermutation(block.permutation.withState("furnicraft:interact",true))
                    }
                    break;
            }
            
        }
    });
});

world.beforeEvents.worldInitialize.subscribe(eventData => {
    eventData.blockComponentRegistry.registerCustomComponent("furnicraft:closetv", {
        onPlayerInteract: e => {
            const { player, block, dimension, item, face, faceLocation} = e;
            const blockLocation = block.center()
            const blockFaceLocation = block.permutation.getState("minecraft:block_face");
            let animationEntity;
            switch(blockFaceLocation){
                case 'north':
                    if ( face === 'North'){
                        block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    }
                    break;
                case 'south':
                    if ( face === 'South'){
                        block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    }
                    break;
                case 'east':
                    if ( face === 'East'){
                        block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    }
                    break;
                case 'west':
                    if ( face === 'West'){
                        block.setPermutation(block.permutation.withState("furnicraft:interact",false))
                    }
                    break;
            }
            
        }
    });
});

//ticking 6,6