import { world, BlockPermutation } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:armchairs", {
        onPlace: e => {
            const { player, block, previousBlock } = e;

            if ( block.north().hasTag("armchair") ) {
                block.setPermutation(block.permutation.withState("furnicraft:north",true));
                block.north().setPermutation(block.north().permutation.withState("furnicraft:south",true));
            }
            if ( block.south().hasTag("armchair") ) {
                block.setPermutation(block.permutation.withState("furnicraft:south",true));
                block.south().setPermutation(block.south().permutation.withState("furnicraft:north",true));
            }
            if ( block.west().hasTag("armchair") ) {
                block.setPermutation(block.permutation.withState("furnicraft:west",true));
                block.west().setPermutation(block.west().permutation.withState("furnicraft:east",true));
            }
            if ( block.east().hasTag("armchair") ) {
                block.setPermutation(block.permutation.withState("furnicraft:east",true));
                block.east().setPermutation(block.east().permutation.withState("furnicraft:west",true));
            }
        },
        onPlayerDestroy: e => {
            const { player, block, dimension } = e;
            if ( block.north().hasTag("armchair") ) {
                block.north().setPermutation(block.north().permutation.withState("furnicraft:south",false));
            }
            if ( block.south().hasTag("armchair") ) {
                block.south().setPermutation(block.south().permutation.withState("furnicraft:north",false));
            }
            if ( block.west().hasTag("armchair") ) {
                block.west().setPermutation(block.west().permutation.withState("furnicraft:east",false));
            }
            if ( block.east().hasTag("armchair") ) {
                block.east().setPermutation(block.east().permutation.withState("furnicraft:west",false));
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:muebletv", {
        onPlace: e => {
            const { player, block, previousBlock } = e;

            if ( block.north().hasTag("muebletv") ) {
                block.setPermutation(block.permutation.withState("furnicraft:north",true));
                block.north().setPermutation(block.north().permutation.withState("furnicraft:south",true));
            }
            if ( block.south().hasTag("muebletv") ) {
                block.setPermutation(block.permutation.withState("furnicraft:south",true));
                block.south().setPermutation(block.south().permutation.withState("furnicraft:north",true));
            }
            if ( block.west().hasTag("muebletv") ) {
                block.setPermutation(block.permutation.withState("furnicraft:west",true));
                block.west().setPermutation(block.west().permutation.withState("furnicraft:east",true));
            }
            if ( block.east().hasTag("muebletv") ) {
                block.setPermutation(block.permutation.withState("furnicraft:east",true));
                block.east().setPermutation(block.east().permutation.withState("furnicraft:west",true));
            }
        },
        onPlayerDestroy: e => {
            const { player, block, dimension } = e;
            if ( block.north().hasTag("muebletv") ) {
                block.north().setPermutation(block.north().permutation.withState("furnicraft:south",false));
            }
            if ( block.south().hasTag("muebletv") ) {
                block.south().setPermutation(block.south().permutation.withState("furnicraft:north",false));
            }
            if ( block.west().hasTag("muebletv") ) {
                block.west().setPermutation(block.west().permutation.withState("furnicraft:east",false));
            }
            if ( block.east().hasTag("muebletv") ) {
                block.east().setPermutation(block.east().permutation.withState("furnicraft:west",false));
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:benchm", {
        onPlace: e => {
            const { player, block, previousBlock } = e;

            if ( block.north().hasTag("benchm") ) {
                block.setPermutation(block.permutation.withState("furnicraft:north",true));
                block.north().setPermutation(block.north().permutation.withState("furnicraft:south",true));
            }
            if ( block.south().hasTag("benchm") ) {
                block.setPermutation(block.permutation.withState("furnicraft:south",true));
                block.south().setPermutation(block.south().permutation.withState("furnicraft:north",true));
            }
            if ( block.west().hasTag("benchm") ) {
                block.setPermutation(block.permutation.withState("furnicraft:west",true));
                block.west().setPermutation(block.west().permutation.withState("furnicraft:east",true));
            }
            if ( block.east().hasTag("benchm") ) {
                block.setPermutation(block.permutation.withState("furnicraft:east",true));
                block.east().setPermutation(block.east().permutation.withState("furnicraft:west",true));
            }
        },
        onPlayerDestroy: e => {
            const { player, block, dimension } = e;
            if ( block.north().hasTag("benchm") ) {
                block.north().setPermutation(block.north().permutation.withState("furnicraft:south",false));
            }
            if ( block.south().hasTag("benchm") ) {
                block.south().setPermutation(block.south().permutation.withState("furnicraft:north",false));
            }
            if ( block.west().hasTag("benchm") ) {
                block.west().setPermutation(block.west().permutation.withState("furnicraft:east",false));
            }
            if ( block.east().hasTag("benchm") ) {
                block.east().setPermutation(block.east().permutation.withState("furnicraft:west",false));
            }
        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:monitor", {
        onPlace: e => {
            const { player, block, previousBlock } = e;

            if ( block.north().hasTag("monitor") ) {
                block.setPermutation(block.permutation.withState("furnicraft:north",true));
                block.north().setPermutation(block.north().permutation.withState("furnicraft:south",true));
            }
            if ( block.south().hasTag("monitor") ) {
                block.setPermutation(block.permutation.withState("furnicraft:south",true));
                block.south().setPermutation(block.south().permutation.withState("furnicraft:north",true));
            }
            if ( block.west().hasTag("monitor") ) {
                block.setPermutation(block.permutation.withState("furnicraft:west",true));
                block.west().setPermutation(block.west().permutation.withState("furnicraft:east",true));
            }
            if ( block.east().hasTag("monitor") ) {
                block.setPermutation(block.permutation.withState("furnicraft:east",true));
                block.east().setPermutation(block.east().permutation.withState("furnicraft:west",true));
            }
        },
        onPlayerDestroy: e => {
            const { player, block, dimension } = e;
            if ( block.north().hasTag("monitor") ) {
                block.north().setPermutation(block.north().permutation.withState("furnicraft:south",false));
            }
            if ( block.south().hasTag("monitor") ) {
                block.south().setPermutation(block.south().permutation.withState("furnicraft:north",false));
            }
            if ( block.west().hasTag("monitor") ) {
                block.west().setPermutation(block.west().permutation.withState("furnicraft:east",false));
            }
            if ( block.east().hasTag("monitor") ) {
                block.east().setPermutation(block.east().permutation.withState("furnicraft:west",false));
            }
        },
    });
});