import { world } from "@minecraft/server";

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:spawn_ride_slides", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            const blockCenter = block.center();

            const chairEntity = dimension.spawnEntity("furnicraft:ejecutes",{ x: blockCenter.x, y: blockCenter.y - 0.2, z: blockCenter.z })

            const faceLocation = block.permutation.getState("minecraft:cardinal_direction");

            switch(faceLocation){
                case 'north':
                    chairEntity.runCommand(`summon furnicraft:columpio_entity ~ ~0.5 ~ facing ~ ~ ~10`)
                    break;
                case 'south':
                    chairEntity.runCommand(`summon furnicraft:columpio_entity ~ ~0.5 ~ facing ~ ~ ~-10`)
                    break;
                case 'east':
                    chairEntity.runCommand(`summon furnicraft:columpio_entity ~ ~0.5 ~ facing ~-10 ~ ~`)
                    break;
                case 'west':
                    chairEntity.runCommand(`summon furnicraft:columpio_entity ~ ~0.5 ~ facing ~10 ~ ~`)
                    break;
            }
            player.runCommand(`ride @s start_riding @e[type=furnicraft:columpio_entity,c=1] teleport_rider`)

        },
    });
});

world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    initEvent.blockComponentRegistry.registerCustomComponent("furnicraft:slide_on", {
        onPlayerInteract: e => {
            const { player, block, dimension } = e;
            player.runCommand(`function slider`)

        },
    });
});
